use std::env;

mod common;
mod one;
mod two;
mod three;
mod four; 
mod five;

fn main() {
    let args: Vec<String> = env::args().collect();

    let day = args.get(1).unwrap();

    let result = match day.as_str() {
        "1" => one::run(),
        "1p2" => one::run_part2(),
        "2" => two::run(),
        "2p2" => two::run_part2(),
        "3" => three::run(),
        "4" => four::run(),
        "4p2" => four::run_part2(),
        "5" => five::run(),
        "5p2" => five::run_part2(),
        _ => Ok(-1),
    };

    match result {
        Ok(val) => println!("Result: {}",val),
        Err(err) => println!("Err: {}",err)
    }
}
