use regex::Regex;

use crate::common::load_input;

fn has_adjacent_symbol(lines: &Vec<String>,pos: (usize,usize)) -> bool {
    let check = move |x: i32,y:i32| {
        is_symbol(get_char(lines, ((x + pos.0 as i32) as usize,(y + pos.1 as i32) as usize)))
    };

    if check(-1,0){return true}
    if check(1,0){return true}
    if check(0,-1){return true}
    if check(0,1){return  true}
    if check(1,-1){return true}
    if check(-1,-1){return true}
    if check(1,1){return true}
    if check(-1,1) {return true}

    return false;
}

fn get_char(lines: &Vec<String>,pos: (usize,usize)) -> char{
    lines.get(pos.1).unwrap_or(&String::from("")).chars().nth(pos.0).unwrap_or('.')
}

fn is_symbol(c: char) -> bool{
    if c >= '0' && c <= '9' {return false;}
    if c == '.' {return false;}
    return  true;
}

fn check_nums(lines: &Vec<String>)-> i32 {
    let re = Regex::new(r"(\d+)").unwrap();
    let mut sum = 0i32;

    for (y,line) in lines.iter().enumerate(){
        let caps = re.captures_iter(line);

        for mat in caps {
            let x_start = mat.get(0).unwrap().start();
            let x_end = mat.get(0).unwrap().end();

            for n in x_start..x_end{
                if has_adjacent_symbol(lines, (n,y)){
                    let match_str = mat.get(0).unwrap().as_str();
                    let num: i32 = match_str.parse().unwrap();
                    println!("{}",num);
                    sum += num;
                    break;
                }
            }

        }
    }

    return sum;
}


pub fn run() -> Result<i32, Box<dyn std::error::Error>>{
    let lines = load_input("./input/3.txt")?;
    Ok(check_nums(&lines))
}
